#include "stage2.h"

/*-------------------------------------------------------------------------*/
void
check(int x, int y, poly_stage2_t *data, double skewness)
{
	int i;
	double alpha, norm, murphye, alpha_max;
	stage2_curr_data_t *s = (stage2_curr_data_t *)data->internal;
	curr_poly_t *c = &s->curr_poly;
	assess_t *assess = &s->assess;

	for (i = 0; i < 6; i++)
		mpz_set(c->gmp_b[i], c->gmp_a[i]);
	mpz_set_si(c->gmp_help1, y);
	mpz_mul(c->gmp_help2, c->gmp_help1, c->gmp_p);
	mpz_add(c->gmp_b[2], c->gmp_b[2], c->gmp_help2);
	mpz_mul(c->gmp_help1, c->gmp_help1, c->gmp_d);
	mpz_sub(c->gmp_b[1], c->gmp_b[1], c->gmp_help1);
	mpz_set_si(c->gmp_help1, x);
	mpz_mul(c->gmp_help2, c->gmp_help1, c->gmp_p);
	mpz_add(c->gmp_b[1], c->gmp_b[1], c->gmp_help2);
	mpz_mul(c->gmp_help1, c->gmp_help1, c->gmp_d);
	mpz_sub(c->gmp_b[0], c->gmp_b[0], c->gmp_help1);
	mpz_set(c->gmp_mb, c->gmp_m);
	for (i = 0; i < 2; i++)
		mpz_set(c->gmp_linb[i], c->gmp_lina[i]);

	optimize_2(c, skewness, &skewness, &norm);

	alpha_max = log(data->max_norm_2 / norm);
	if (murphy_alpha(&alpha, 5, assess, c->gmp_b, alpha_max)) {
		return;
	}

	if (norm * exp(alpha) > data->max_norm_2) {
		return;
	}

	optimize_3(c, data, assess, skewness, 
			&skewness, &norm, &murphye, &alpha);
	if (murphye < data->min_e) {
		return;
	}
	data->callback(data->callback_data, 5, c->gmp_b, c->gmp_linb, 
				skewness, norm, alpha, murphye);
}

